Index: LMDZ4/branches/V3_test/libf/phylmd/phytrac.F
===================================================================
--- LMDZ4/branches/V3_test/libf/phylmd/phytrac.F	(revision 704)
+++ LMDZ4/branches/V3_test/libf/phylmd/phytrac.F	(revision 726)
@@ -67,33 +67,5 @@
       USE iophy
       USE vampir
-#ifdef INCA
-      USE sflx
-      USE chem_tracnm
-      USE species_names
-      USE chem_mods
-#ifdef INCA_NMHC
-      USE pht_tables, ONLY : jrates
-      USE lightning, ONLY : prod_light
-#endif
-#ifdef INCA_CH4
-      USE pht_tables, ONLY : jrates
-      USE lightning, ONLY : prod_light
-#endif
-      USE transport_controls, ONLY : conv_flg, pbl_flg
-      USE airplane_src, ONLY : ptrop
-#ifdef INCA_AER
-      USE AEROSOL_MOD, only : ntr,trmx,trnx
-      USE AEROSOL_DIAG,only : cla,las,tausum,angst,aload,cload,totaerh2o,tau,
-     $  emiss20,sconc,scavcoef_st,scavcoef_cv
-     $  ,cload05ss  ,cload05bc  ,cload05pom  ,cload05dust  ,cload05so4
-     $  ,cload125ss  ,cload125bc  ,cload125pom  ,cload125dust  ,cload125so4
-      USE AEROSOL_PROGNOS, ONLY : md,mdw
-      USE AEROSOL_METEO, only : airm
-#endif
-#ifdef INCA_NMHC
-      USE RESISTANCE_DIAGNOSE, ONLY : surf_alb, sol_irrad, surf_temp, surf_wind,
-     $                                aero_resist, lamin_resist, surf_resist
-#endif
-#endif
+
       IMPLICIT none
 c======================================================================
@@ -165,4 +137,5 @@
 #ifdef INCA
       REAL flxmass_w(klon,klev)
+      CHARACTER(len=8) :: solsym(nqmax)
 #endif
 c      integer iflag_con
@@ -230,5 +203,5 @@
 cAA Pour l'instant seuls les cas du rn et du pb ont ete envisages.
 
-      REAL source(klon)       ! a voir lorsque le flux est prescrit 
+      REAL source(klon,nqmax)       ! a voir lorsque le flux est prescrit 
 cAA 
 cAA Pour la source de radon et son reservoir de sol
@@ -365,46 +338,5 @@
       INTEGER           :: lastgas
       INTEGER           :: ncsec
-
-      INTEGER           :: prt_flag_ts(nbtr)=(/
-#ifdef INCA_CH4
-     .                                         1,1,1,0,0,1,1,1,1,1,
-     .                                         0,1,0,0,0,0,0,1,0,0,
-     .                                         0,1,1,1,1,0,1,1,1,0,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,0,0
-#ifdef INCA_AER 
-     .                                        ,1,1,1,1,0,1,1,1,1,0,
-     .                                         1,1,1,1,1,1,0,1,0,1,
-     .                                         1,1,1,1,0,1,0,1,1,1
-#endif
-#endif
-#ifdef INCA_NMHC
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1
-#ifdef INCA_AER 
-     .                                        ,1,1,1,1,0,1,1,1,1,0,
-     .                                         1,1,1,1,1,1,0,1,0,1,
-     .                                         1,1,1,1,0,1,0,1,1,1
-#endif
-#endif
-#if defined(INCA_AER) && !defined(INCA_CH4) && !defined(INCA_NMHC)
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1,1,1,1,1,1,1,1,1
-#endif
-#if defined(INCA) && !defined(INCA_CH4) && !defined(INCA_NMHC) && !defined(INCA_AER)
-     .                                         1,1,1,1,1,1,1,1,1,1,
-     .                                         1                                         
-#endif
-
-     .                                         /)
-
+      INTEGER           :: prt_flag_ts(nbtr)  
 
       REAL, PARAMETER   :: dry_mass = 28.966
@@ -413,5 +345,5 @@
       REAL              :: calday
       REAL              :: pdel(klon,klev)
-      REAL              :: dummy(klon,klev) = 0.
+      REAL              :: dummy(klon,klev)
 #endif
 #ifdef INCA_AER
@@ -420,4 +352,49 @@
 c
 c======================================================================
+
+#ifdef INCA
+      prt_flag_ts(:)=(/
+#ifdef INCA_CH4
+     .             1,1,1,0,0,1,1,1,1,1,
+     .             0,1,0,0,0,0,0,1,0,0,
+     .             0,1,1,1,1,0,1,1,1,0,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,0,0
+#ifdef INCA_AER 
+     .             ,1,1,1,1,0,1,1,1,1,0,
+     .             1,1,1,1,1,1,0,1,0,1,
+     .             1,1,1,1,0,1,0,1,1,1
+#endif
+#endif
+#ifdef INCA_NMHC
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1
+#ifdef INCA_AER 
+     .             ,1,1,1,1,0,1,1,1,1,0,
+     .             1,1,1,1,1,1,0,1,0,1,
+     .             1,1,1,1,0,1,0,1,1,1
+#endif
+#endif
+#if defined(INCA_AER) && !defined(INCA_CH4) && !defined(INCA_NMHC)
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1,1,1,1,1,1,1,1,1
+#endif
+#if defined(INCA) && !defined(INCA_CH4) && !defined(INCA_NMHC) && !defined(INCA_AER)
+     .             1,1,1,1,1,1,1,1,1,1,
+     .             1                                         
+#endif
+
+     .             /)
+      dummy(:,:) = 0.
+
+#endif
          modname='phytrac'
 
@@ -549,5 +526,6 @@
      $                 rneb,         ! for chimiaq
      $                 t_seri,       ! for chimiaq
-     $                 rh)
+     $                 rh,
+     $                 lafin)
 ! fin changement anne
 
@@ -555,5 +533,4 @@
 
         CALL chemmain (tr_seri,    !mmr
-     $                 nas,        !nas
      $                 nstep,      !nstep
      $                 calday,     !calday
@@ -590,5 +567,7 @@
      $                 obuf,       !obuf
      $                 iip1,       !nx
-     $                 jjp1)       !ny
+     $                 jjp1,       !ny
+     $                 source,
+     $                 solsym)
 #ifdef INCAINFO
 #ifdef INCA_AER
@@ -797,18 +776,14 @@
 C         CALL minmaxqfi(tr_seri(1,1,it),0.,1.e33,'cltracrn it='//itn)
       else ! couche limite avec flux prescrit
-#ifdef INCA
-        DO k =  1, klon
-          source(k) = eflux(k,it)-dflux(k,it)
-        END DO
-#else
+#ifndef INCA
 
 Cmaf provisoire source / traceur a creer
         DO i=1, klon
-          source(i) = 0.0 ! pas de source, pour l'instant
+          source(i,it) = 0.0 ! pas de source, pour l'instant
         ENDDO
 C
 #endif
           CALL cltrac(pdtphys, coefh,t_seri,
-     s               tr_seri(1,1,it), source,
+     s               tr_seri(1,1,it), source(:,it),
      e               paprs, pplay, delp,
      s               d_tr_cl(1,1,it))