Index: LMDZ4/branches/V3_test/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/leapfrog_p.F	(revision 735)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/leapfrog_p.F	(revision 743)
@@ -418,4 +418,9 @@
      &                                jj_Nb_caldyn,0,0,TestRequest)
  
+	do j=1,nqmx
+         call Register_SwapFieldHallo(q(1,1,j),q(1,1,j),ip1jmp1,llm,
+     &                                jj_nb_caldyn,0,0,TestRequest)
+        enddo
+
          call SetDistrib(jj_nb_caldyn)
          call SendRequest(TestRequest)
@@ -478,8 +483,8 @@
         call WriteField_p('pkf',reshape(pkf,(/iip1,jmp1,llm/)))
         call WriteField_p('phis',reshape(phis,(/iip1,jmp1/)))
-c        do j=1,nqmx
-c          call WriteField_p('q'//trim(int2str(j)),
-c     .                reshape(q(:,:,j),(/iip1,jmp1,llm/)))
-c        enddo        
+        do j=1,nqmx
+          call WriteField_p('q'//trim(int2str(j)),
+     .                reshape(q(:,:,j),(/iip1,jmp1,llm/)))
+        enddo        
       endif
  
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/times.F90
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/times.F90	(revision 735)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/times.F90	(revision 743)
@@ -126,5 +126,5 @@
 	V2=timer_table_sqr(jj_nb,no_timer,mpi_rank)
 	V=timer_table(jj_nb,no_timer,mpi_rank)
-	timer_delta(jj_nb,no_timer,mpi_rank)=sqrt((V2-V*V/N)/(N-1)) 
+	timer_delta(jj_nb,no_timer,mpi_rank)=sqrt(abs(V2-V*V/N)/(N-1)) 
       else
         timer_delta(jj_nb,no_timer,mpi_rank)=0
Index: LMDZ4/branches/V3_test/libf/phylmd/ini_histrac.h
===================================================================
--- LMDZ4/branches/V3_test/libf/phylmd/ini_histrac.h	(revision 735)
+++ LMDZ4/branches/V3_test/libf/phylmd/ini_histrac.h	(revision 743)
@@ -3,4 +3,5 @@
 !
 #ifndef INCA
+c$OMP MASTER 
          CALL ymds2ju(annee_ref, 1, day_ref, 0.0, zjulian)
 c
@@ -125,3 +126,4 @@
          ndex3d = 0
          ndex = 0
+c$OMP END MASTER
 #endif
Index: LMDZ4/branches/V3_test/libf/phylmd/interface_surf.F90
===================================================================
--- LMDZ4/branches/V3_test/libf/phylmd/interface_surf.F90	(revision 735)
+++ LMDZ4/branches/V3_test/libf/phylmd/interface_surf.F90	(revision 743)
@@ -2065,11 +2065,13 @@
 ! sorties NETCDF des champs recus
 !
-!ym       ndexcs(:)=0
-!ym       itau_w = itau_phy + itime
-!ym       CALL histwrite(nidcs,cl_read(1),itau_w,read_sst,iim*(jjm+1),ndexcs)
-!ym       CALL histwrite(nidcs,cl_read(2),itau_w,read_sic,iim*(jjm+1),ndexcs)
-!ym       CALL histwrite(nidcs,cl_read(3),itau_w,read_alb_sic,iim*(jjm+1),ndexcs)
-!ym       CALL histwrite(nidcs,cl_read(4),itau_w,read_sit,iim*(jjm+1),ndexcs)
-!ym       CALL histsync(nidcs)
+     if (monocpu) THEN
+       ndexcs(:)=0
+       itau_w = itau_phy + itime
+       CALL histwrite(nidcs,cl_read(1),itau_w,read_sst,iim*(jjm+1),ndexcs)
+       CALL histwrite(nidcs,cl_read(2),itau_w,read_sic,iim*(jjm+1),ndexcs)
+       CALL histwrite(nidcs,cl_read(3),itau_w,read_alb_sic,iim*(jjm+1),ndexcs)
+       CALL histwrite(nidcs,cl_read(4),itau_w,read_sit,iim*(jjm+1),ndexcs)
+       CALL histsync(nidcs)
+     endif
 ! pas utile      IF (npas-itime.LT.nexca )CALL histclo(nidcs)
 
@@ -2401,5 +2403,5 @@
       tmp_field(ig) = 1.
     enddo    
-    call WriteField_phy('knindex',tmp_field,1)
+!ym    call WriteField_phy('knindex',tmp_field,1)
     
     tmp_field=0.
@@ -2408,5 +2410,5 @@
       tmp_field(ig) = tsurf_new(i)
     enddo    
-    call WriteField_phy('tsurf_new',tmp_field,1)
+!ym    call WriteField_phy('tsurf_new',tmp_field,1)
     
     tmp_field=0.
@@ -2415,5 +2417,5 @@
       tmp_field(ig) = alb_new(i)
     enddo    
-    call WriteField_phy('alb_new',tmp_field,1)
+!ym    call WriteField_phy('alb_new',tmp_field,1)
     
 !    tmp_field=0.
@@ -2422,5 +2424,5 @@
 !      tmp_field(ig) = pctsrf_new(i,nisurf)
  !   enddo    
-    call WriteField_phy('pctsrf_new', pctsrf_new(:,nisurf),1)
+!ym    call WriteField_phy('pctsrf_new', pctsrf_new(:,nisurf),1)
   endif
 !ym  do j=1,jjphy_nb
Index: LMDZ4/branches/V3_test/libf/phylmd/isccp_cloud_types.F
===================================================================
--- LMDZ4/branches/V3_test/libf/phylmd/isccp_cloud_types.F	(revision 735)
+++ LMDZ4/branches/V3_test/libf/phylmd/isccp_cloud_types.F	(revision 743)
@@ -32,5 +32,4 @@
      &)
 	
-!$Id$
 
 ! Copyright Steve Klein and Mark Webb 2002 - all rights reserved.
Index: LMDZ4/branches/V3_test/libf/phylmd/oasis.dummy
===================================================================
--- LMDZ4/branches/V3_test/libf/phylmd/oasis.dummy	(revision 735)
+++ LMDZ4/branches/V3_test/libf/phylmd/oasis.dummy	(revision 743)
@@ -95,8 +95,8 @@
       cl_writ(18)='CORIVFLU'
       cl_writ(19)='COCALVIN'
-c$$$      cl_writ(13)='COZOTAUX'
-c$$$      cl_writ(14)='COZOTAUV'
-c$$$      cl_writ(15)='COMETAUY'
-c$$$      cl_writ(16)='COMETAUU'
+cxxx      cl_writ(13)='COZOTAUX'
+cxxx      cl_writ(14)='COZOTAUV'
+cxxx      cl_writ(15)='COMETAUY'
+cxxx      cl_writ(16)='COMETAUU'
       cl_writ(1)='COTAUXXU'
       cl_writ(2)='COTAUYYU'
@@ -365,8 +365,8 @@
       REAL rivrunoff(imjm)
       REAL calving(imjm)
-c$$$      REAL tauxu(imjm)
-c$$$      REAL tauxv(imjm)
-c$$$      REAL tauyu(imjm)
-c$$$      REAL tauyv(imjm)
+cxxx      REAL tauxu(imjm)
+cxxx      REAL tauxv(imjm)
+cxxx      REAL tauyu(imjm)
+cxxx      REAL tauyv(imjm)
       REAL tauxx_u(imjm)
       REAL tauxx_v(imjm)
@@ -496,16 +496,16 @@
      $          CALL locwrite(cl_writ(jf),calving, imjm,
      $          file_unit_field(jf), ierror) 
-c$$$            IF (jf.eq.13)
-c$$$     $          CALL locwrite(cl_writ(jf),tauxu, imjm,
-c$$$     $          file_unit_field(jf),ierror) 
-c$$$            IF (jf.eq.1')
-c$$$     $          CALL locwrite(cl_writ(jf),tauxv, imjm,
-c$$$     $          file_unit_field(jf),ierror) 
-c$$$            IF (jf.eq.15)
-c$$$     $          CALL locwrite(cl_writ(jf),tauyv, imjm,
-c$$$     $          file_unit_field(jf),ierror) 
-c$$$            IF (jf.eq.16)
-c$$$     $          CALL locwrite(cl_writ(jf),tauyu, imjm,
-c$$$     $          file_unit_field(jf), ierror) 
+cxxx            IF (jf.eq.13)
+cxxx     $          CALL locwrite(cl_writ(jf),tauxu, imjm,
+cxxx     $          file_unit_field(jf),ierror) 
+cxxx            IF (jf.eq.1')
+cxxx     $          CALL locwrite(cl_writ(jf),tauxv, imjm,
+cxxx     $          file_unit_field(jf),ierror) 
+cxxx            IF (jf.eq.15)
+cxxx     $          CALL locwrite(cl_writ(jf),tauyv, imjm,
+cxxx     $          file_unit_field(jf),ierror) 
+cxxx            IF (jf.eq.16)
+cxxx     $          CALL locwrite(cl_writ(jf),tauyu, imjm,
+cxxx     $          file_unit_field(jf), ierror) 
             IF (jf.eq.1)
      $          CALL locwrite(cl_writ(jf),tauxx_u, imjm,
@@ -574,8 +574,8 @@
           IF (jn.eq.18) CALL CLIM_Export(cl_writ(jn),kt,rivrunoff,info)
           IF (jn.eq.19) CALL CLIM_Export(cl_writ(jn),kt,calving,info)
-c$$$          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, tauxu, info)
-c$$$          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, tauxv, info)
-c$$$          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, tauyv, info)
-c$$$          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, tauyu, info)
+cxxx          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, tauxu, info)
+cxxx          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, tauxv, info)
+cxxx          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, tauyv, info)
+cxxx          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, tauyu, info)
           IF (jn.eq.1) CALL CLIM_Export(cl_writ(jn), kt, tauxx_u, info)
           IF (jn.eq.2) CALL CLIM_Export(cl_writ(jn), kt, tauyy_u, info)